#include "module.h"
#define AUTHOR "SGR"
#define VERSION "1.20"

int do_killingspree(User * u);
int SGR_Module_Help_OPERSERV_MKILL_FULL(User *u);
void SGR_Module_Help_OPERSERV_MKILL(User *u);


void AnopeInit(void) {
        Command *c;
        c = createCommand("MKILL",do_killingspree,is_services_admin,-1,-1,-1,-1,-1);                  
	moduleAddHelp(c,SGR_Module_Help_OPERSERV_MKILL_FULL);
        moduleSetOperHelp(SGR_Module_Help_OPERSERV_MKILL);
        alog("Loading module os_mkill.so [Status: %d]",moduleAddCommand(OPERSERV,c,MOD_HEAD));
        moduleAddAuthor(AUTHOR);
        moduleAddVersion(VERSION);
        return;
}

void AnopeFini(void) {
        alog("Unloading os_mkill.so");
}

void SGR_Module_Help_OPERSERV_MKILL(User *u)
{
   if (is_services_admin(u)) {
       notice(s_OperServ, u->nick, "    MKILL       Mass Kill en fonction d'un salon ou host");
   }
   return;
}


int SGR_Module_Help_OPERSERV_MKILL_FULL(User *u)
{
    if (is_oper(u)) {
                notice(s_OperServ, u->nick, "-----------------------------------------------------------------------");
                notice(s_OperServ, u->nick, " Syntaxe : MKILL #salon/host raison");
                notice(s_OperServ, u->nick, "   ");
                notice(s_OperServ, u->nick, " Cette commande sert  faire un mass kill sur un salon");
                notice(s_OperServ, u->nick, " ou sur une host, les Ircops ne seront pas kills");
                notice(s_OperServ, u->nick, "-----------------------------------------------------------------------");
                return MOD_STOP;
   }

}

int do_killingspree(User * u)
{
    char *pattern = strtok(NULL, " ");
    char *givenreason = strtok(NULL, "");
    int killed = 0; 
    Channel *c;

    if (!pattern) {
        notice(s_OperServ, u->nick, "Syntaxe : MKILL #salon/host raison");
        return MOD_STOP;
    }
    

    if (givenreason) {
       if (strlen(givenreason) > 400) {
          notice(s_OperServ, u->nick, "Votre message de kill est trop long.");
          return MOD_STOP;
       }  
    }
    if (!(givenreason)) {
        givenreason = "NO REASON";
    }
 
    if (pattern && (c = findchan(pattern))) {
        struct c_userlist *cu, *next;
        for (cu = c->users; cu; cu = next) {
             next = cu->next; 
             if (!is_oper(cu->user)) {
                kill_user(s_OperServ, cu->user->nick, givenreason);
		killed++;
             }
        }
        notice(s_OperServ, u->nick, "Killed %d users", killed); 
        return MOD_STOP;
    }
    else 
    {
    char mask[BUFSIZE];
    int i;
    User *u2;
    User *next;
       if (strlen(pattern) < 5) {
          notice(s_OperServ, u->nick, "L'host doit tre de type Nick!Ident@Host");
          return MOD_CONT;
       } 
       if ( (!(strstr(pattern,"!"))) || (!(strstr(pattern,"@")))) {
          notice(s_OperServ, u->nick, "L'host doit tre de type Nick!Ident@Host");
          return MOD_CONT;
       } 
       if ((stricmp(pattern,"*") == 0) || (stricmp(pattern,"*!*@*") == 0)) {
          notice_lang(s_OperServ, u, USERHOST_MASK_TOO_WIDE, pattern);
          return MOD_CONT;
       } 
       if (pattern && strspn(pattern, "!*@*?") > strlen(pattern)) {
          notice_lang(s_OperServ, u, USERHOST_MASK_TOO_WIDE, pattern);
          return MOD_CONT;
       }
    for (i = 0; i < 1024; i++) {
        for (u2 = userlist[i]; u2; u2 = next) {
            next = u2->next;
            if (pattern) {
                snprintf(mask, sizeof(mask), "%s!%s@%s", u2->nick, u2->username, GetHost(u2));
                if (!match_wild_nocase(pattern, mask))
                    continue;
                }
                if (!is_oper(u2)) {
		    kill_user(s_OperServ, u2->nick, givenreason);
		    killed++;
                }
            }
        }
    }
notice(s_OperServ, u->nick, "Killed %d users", killed);
return MOD_CONT;
}
